searchNodes=[{"doc":"Grains describes data flow as a graph with interchangeable parts. To accomplish that grains divides the graph (Recipe) from the implementation of the nodes (Grains). Together these parts can be used to make a Bread which describes how the graph translates to processes. Each process has a symbolic short name, which is resolved to the registered name of the process via a map (%Bread{}.process_map).","ref":"Grains.html","title":"Grains","type":"module"},{"doc":"Combine two sets of recipes and grains.","ref":"Grains.html#combine/2","title":"Grains.combine/2","type":"function"},{"doc":"","ref":"Grains.html#concat_name/2","title":"Grains.concat_name/2","type":"function"},{"doc":"This function describes the default implementations for auxiliary grains, for example the periodic timer. Currently these default grains are provided: iex&gt; Grains.default_grains() %{periodic: Grains.Timer}","ref":"Grains.html#default_grains/0","title":"Grains.default_grains/0","type":"function"},{"doc":"","ref":"Grains.html#get_name/2","title":"Grains.get_name/2","type":"function"},{"doc":"Retrieve a grain&#39;s substate. This is similar to :sys.get_state/1. Note that this function should usually not be used, but it can be useful for debugging or testing. Errors The function exits the caller on error. For example, if no bread with the supplied id can be found, this results in a no_proc exit.","ref":"Grains.html#get_substate/1","title":"Grains.get_substate/1","type":"function"},{"doc":"","ref":"Grains.html#make_bread_name/2","title":"Grains.make_bread_name/2","type":"function"},{"doc":"","ref":"Grains.html#make_name/3","title":"Grains.make_name/3","type":"function"},{"doc":"Merges two grain maps into one. The function works the same as Map.merge/2: all grains in the second argument are added to the first, overriding any existing one.","ref":"Grains.html#merge/2","title":"Grains.merge/2","type":"function"},{"doc":"See Grains.Recipe.merge/3.","ref":"Grains.html#merge_recipes/3","title":"Grains.merge_recipes/3","type":"function"},{"doc":"","ref":"Grains.html#new/1","title":"Grains.new/1","type":"function"},{"doc":"See Grains.Recipe.new/2.","ref":"Grains.html#new_recipe/2","title":"Grains.new_recipe/2","type":"function"},{"doc":"Description of a periodic grain.","ref":"Grains.html#periodic/3","title":"Grains.periodic/3","type":"function"},{"doc":"See Grains.Supervisor.start_link/3.","ref":"Grains.html#start_supervised/3","title":"Grains.start_supervised/3","type":"function"},{"doc":"A %Bread{} is the compiled version of Recipe plus Grains that allow the Supervisor to run the processes and wire them correctly.","ref":"Grains.Bread.html","title":"Grains.Bread","type":"module"},{"doc":"Takes a recipe, grains and optionally a map of default implementations and returns a bread. Does not start any processes yet. Optional Arguments :default_grains Replace the default grains :id Set a custom bread id","ref":"Grains.Bread.html#bake/3","title":"Grains.Bread.bake/3","type":"function"},{"doc":"","ref":"Grains.Bread.html#check/1","title":"Grains.Bread.check/1","type":"function"},{"doc":"Generates a random atom to be used as an id for the Bread","ref":"Grains.Bread.html#gen_id/0","title":"Grains.Bread.gen_id/0","type":"function"},{"doc":"","ref":"Grains.Bread.html#t:t/0","title":"Grains.Bread.t/0","type":"type"},{"doc":"Debug version of Grains.Timer. To replace the normal Timer with this, start you bread like this: default_grains = Map.merge(Grains.default_grains, %{periodic: Grains.DebugTimer}) {:ok, bread} = Grains.Supervisor.start_link(recipe, grains, default_grains) server = Grains.get_name(bread, State) debug_timer = Grains.get_name(bread, State.Sampler.Timer) send(debug_timer, :tick) With Timestamps Similarly to Grains.Timer, the debug timer accepts an option with_timestamps. If set to true, the :tick must include a timestamp, which is then used when forwarding the received message downstream. If with_timestamps is not set, the :tick must not include a timestamp, and the message is forwarded as-is.","ref":"Grains.DebugTimer.html","title":"Grains.DebugTimer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.DebugTimer.html#child_spec/1","title":"Grains.DebugTimer.child_spec/1","type":"function"},{"doc":"","ref":"Grains.DebugTimer.html#handle_pull/2","title":"Grains.DebugTimer.handle_pull/2","type":"function"},{"doc":"","ref":"Grains.DebugTimer.html#handle_push/3","title":"Grains.DebugTimer.handle_push/3","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Grains.DebugTimer.html#init/1","title":"Grains.DebugTimer.init/1","type":"function"},{"doc":"See Grains.Timer.name/2.","ref":"Grains.DebugTimer.html#name/2","title":"Grains.DebugTimer.name/2","type":"function"},{"doc":"See Grains.GenGrain.own_full_name/0.","ref":"Grains.DebugTimer.html#own_full_name/0","title":"Grains.DebugTimer.own_full_name/0","type":"function"},{"doc":"See Grains.GenGrain.own_name/0.","ref":"Grains.DebugTimer.html#own_name/0","title":"Grains.DebugTimer.own_name/0","type":"function"},{"doc":"See Grains.GenGrain.pull/0.","ref":"Grains.DebugTimer.html#pull/0","title":"Grains.DebugTimer.pull/0","type":"function"},{"doc":"See Grains.GenGrain.pull/1.","ref":"Grains.DebugTimer.html#pull/1","title":"Grains.DebugTimer.pull/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/1.","ref":"Grains.DebugTimer.html#pull_with_tag/1","title":"Grains.DebugTimer.pull_with_tag/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/2.","ref":"Grains.DebugTimer.html#pull_with_tag/2","title":"Grains.DebugTimer.pull_with_tag/2","type":"function"},{"doc":"See Grains.GenGrain.push/1.","ref":"Grains.DebugTimer.html#push/1","title":"Grains.DebugTimer.push/1","type":"function"},{"doc":"See Grains.GenGrain.push/2.","ref":"Grains.DebugTimer.html#push/2","title":"Grains.DebugTimer.push/2","type":"function"},{"doc":"","ref":"Grains.DebugTimer.State.html","title":"Grains.DebugTimer.State","type":"module"},{"doc":"","ref":"Grains.GenGrain.html","title":"Grains.GenGrain","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.GenGrain.html#child_spec/1","title":"Grains.GenGrain.child_spec/1","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#full_name/1","title":"Grains.GenGrain.full_name/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2.","ref":"Grains.GenGrain.html#handle_continue/2","title":"Grains.GenGrain.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Grains.GenGrain.html#init/1","title":"Grains.GenGrain.init/1","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#own_full_name/0","title":"Grains.GenGrain.own_full_name/0","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#own_name/0","title":"Grains.GenGrain.own_name/0","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#pull/0","title":"Grains.GenGrain.pull/0","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#pull/1","title":"Grains.GenGrain.pull/1","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#pull_with_tag/1","title":"Grains.GenGrain.pull_with_tag/1","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#pull_with_tag/2","title":"Grains.GenGrain.pull_with_tag/2","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#push/1","title":"Grains.GenGrain.push/1","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#push/2","title":"Grains.GenGrain.push/2","type":"function"},{"doc":"","ref":"Grains.GenGrain.html#start_link/5","title":"Grains.GenGrain.start_link/5","type":"function"},{"doc":"A Recipe describes the data flow between the processes.","ref":"Grains.Recipe.html","title":"Grains.Recipe","type":"module"},{"doc":"Merges to recipes by combining all edges.","ref":"Grains.Recipe.html#merge/3","title":"Grains.Recipe.merge/3","type":"function"},{"doc":"","ref":"Grains.Recipe.html#new/2","title":"Grains.Recipe.new/2","type":"function"},{"doc":"","ref":"Grains.Recipe.html#t:t/0","title":"Grains.Recipe.t/0","type":"type"},{"doc":"","ref":"Grains.Supervisor.html","title":"Grains.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.Supervisor.html#child_spec/1","title":"Grains.Supervisor.child_spec/1","type":"function"},{"doc":"Retrieve the bread supervisor. Crashes if :bread_supervisor is not started.","ref":"Grains.Supervisor.html#get_bread_supervisor/1","title":"Grains.Supervisor.get_bread_supervisor/1","type":"function"},{"doc":"Retrieve the root bread name. This function assumes that the supervisor has a registered name.","ref":"Grains.Supervisor.html#get_root_name/1","title":"Grains.Supervisor.get_root_name/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Grains.Supervisor.html#init/1","title":"Grains.Supervisor.init/1","type":"function"},{"doc":"","ref":"Grains.Supervisor.html#start_link/3","title":"Grains.Supervisor.start_link/3","type":"function"},{"doc":"Retrieve the id and registered name of currently running grains.","ref":"Grains.Supervisor.html#which_grains/1","title":"Grains.Supervisor.which_grains/1","type":"function"},{"doc":"","ref":"Grains.Supervisor.html#t:t/0","title":"Grains.Supervisor.t/0","type":"type"},{"doc":"A grain to forward messages downstream and cache the last value it received. This grain is meant for testing purposes, where another grain is to be tested.","ref":"Grains.Support.Cache.html","title":"Grains.Support.Cache","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.Support.Cache.html#child_spec/1","title":"Grains.Support.Cache.child_spec/1","type":"function"},{"doc":"","ref":"Grains.Support.Cache.html#handle_pull/2","title":"Grains.Support.Cache.handle_pull/2","type":"function"},{"doc":"","ref":"Grains.Support.Cache.html#handle_push/3","title":"Grains.Support.Cache.handle_push/3","type":"function"},{"doc":"See Grains.GenGrain.own_full_name/0.","ref":"Grains.Support.Cache.html#own_full_name/0","title":"Grains.Support.Cache.own_full_name/0","type":"function"},{"doc":"See Grains.GenGrain.own_name/0.","ref":"Grains.Support.Cache.html#own_name/0","title":"Grains.Support.Cache.own_name/0","type":"function"},{"doc":"See Grains.GenGrain.pull/0.","ref":"Grains.Support.Cache.html#pull/0","title":"Grains.Support.Cache.pull/0","type":"function"},{"doc":"See Grains.GenGrain.pull/1.","ref":"Grains.Support.Cache.html#pull/1","title":"Grains.Support.Cache.pull/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/1.","ref":"Grains.Support.Cache.html#pull_with_tag/1","title":"Grains.Support.Cache.pull_with_tag/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/2.","ref":"Grains.Support.Cache.html#pull_with_tag/2","title":"Grains.Support.Cache.pull_with_tag/2","type":"function"},{"doc":"See Grains.GenGrain.push/1.","ref":"Grains.Support.Cache.html#push/1","title":"Grains.Support.Cache.push/1","type":"function"},{"doc":"See Grains.GenGrain.push/2.","ref":"Grains.Support.Cache.html#push/2","title":"Grains.Support.Cache.push/2","type":"function"},{"doc":"A grain to forward messages downstream. This grain is meant for testing purposes, where another grain is to be tested.","ref":"Grains.Support.Publisher.html","title":"Grains.Support.Publisher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.Support.Publisher.html#child_spec/1","title":"Grains.Support.Publisher.child_spec/1","type":"function"},{"doc":"","ref":"Grains.Support.Publisher.html#handle_pull/2","title":"Grains.Support.Publisher.handle_pull/2","type":"function"},{"doc":"","ref":"Grains.Support.Publisher.html#handle_pull/3","title":"Grains.Support.Publisher.handle_pull/3","type":"function"},{"doc":"See Grains.GenGrain.own_full_name/0.","ref":"Grains.Support.Publisher.html#own_full_name/0","title":"Grains.Support.Publisher.own_full_name/0","type":"function"},{"doc":"See Grains.GenGrain.own_name/0.","ref":"Grains.Support.Publisher.html#own_name/0","title":"Grains.Support.Publisher.own_name/0","type":"function"},{"doc":"See Grains.GenGrain.pull/0.","ref":"Grains.Support.Publisher.html#pull/0","title":"Grains.Support.Publisher.pull/0","type":"function"},{"doc":"See Grains.GenGrain.pull/1.","ref":"Grains.Support.Publisher.html#pull/1","title":"Grains.Support.Publisher.pull/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/1.","ref":"Grains.Support.Publisher.html#pull_with_tag/1","title":"Grains.Support.Publisher.pull_with_tag/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/2.","ref":"Grains.Support.Publisher.html#pull_with_tag/2","title":"Grains.Support.Publisher.pull_with_tag/2","type":"function"},{"doc":"See Grains.GenGrain.push/1.","ref":"Grains.Support.Publisher.html#push/1","title":"Grains.Support.Publisher.push/1","type":"function"},{"doc":"See Grains.GenGrain.push/2.","ref":"Grains.Support.Publisher.html#push/2","title":"Grains.Support.Publisher.push/2","type":"function"},{"doc":"A grain to pull message and forward pushed messages to a subscribing process. This grain is meant for testing purposes, where the incoming messages should be forwarded to the test process.","ref":"Grains.Support.Subscriber.html","title":"Grains.Support.Subscriber","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.Support.Subscriber.html#child_spec/1","title":"Grains.Support.Subscriber.child_spec/1","type":"function"},{"doc":"","ref":"Grains.Support.Subscriber.html#handle_push/3","title":"Grains.Support.Subscriber.handle_push/3","type":"function"},{"doc":"See Grains.GenGrain.own_full_name/0.","ref":"Grains.Support.Subscriber.html#own_full_name/0","title":"Grains.Support.Subscriber.own_full_name/0","type":"function"},{"doc":"See Grains.GenGrain.own_name/0.","ref":"Grains.Support.Subscriber.html#own_name/0","title":"Grains.Support.Subscriber.own_name/0","type":"function"},{"doc":"See Grains.GenGrain.pull/0.","ref":"Grains.Support.Subscriber.html#pull/0","title":"Grains.Support.Subscriber.pull/0","type":"function"},{"doc":"See Grains.GenGrain.pull/1.","ref":"Grains.Support.Subscriber.html#pull/1","title":"Grains.Support.Subscriber.pull/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/1.","ref":"Grains.Support.Subscriber.html#pull_with_tag/1","title":"Grains.Support.Subscriber.pull_with_tag/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/2.","ref":"Grains.Support.Subscriber.html#pull_with_tag/2","title":"Grains.Support.Subscriber.pull_with_tag/2","type":"function"},{"doc":"See Grains.GenGrain.push/1.","ref":"Grains.Support.Subscriber.html#push/1","title":"Grains.Support.Subscriber.push/1","type":"function"},{"doc":"See Grains.GenGrain.push/2.","ref":"Grains.Support.Subscriber.html#push/2","title":"Grains.Support.Subscriber.push/2","type":"function"},{"doc":"A periodic timer.","ref":"Grains.Timer.html","title":"Grains.Timer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Grains.Timer.html#child_spec/1","title":"Grains.Timer.child_spec/1","type":"function"},{"doc":"","ref":"Grains.Timer.html#handle_pull/2","title":"Grains.Timer.handle_pull/2","type":"function"},{"doc":"","ref":"Grains.Timer.html#handle_push/3","title":"Grains.Timer.handle_push/3","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Grains.Timer.html#init/1","title":"Grains.Timer.init/1","type":"function"},{"doc":"","ref":"Grains.Timer.html#name/2","title":"Grains.Timer.name/2","type":"function"},{"doc":"See Grains.GenGrain.own_full_name/0.","ref":"Grains.Timer.html#own_full_name/0","title":"Grains.Timer.own_full_name/0","type":"function"},{"doc":"See Grains.GenGrain.own_name/0.","ref":"Grains.Timer.html#own_name/0","title":"Grains.Timer.own_name/0","type":"function"},{"doc":"See Grains.GenGrain.pull/0.","ref":"Grains.Timer.html#pull/0","title":"Grains.Timer.pull/0","type":"function"},{"doc":"See Grains.GenGrain.pull/1.","ref":"Grains.Timer.html#pull/1","title":"Grains.Timer.pull/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/1.","ref":"Grains.Timer.html#pull_with_tag/1","title":"Grains.Timer.pull_with_tag/1","type":"function"},{"doc":"See Grains.GenGrain.pull_with_tag/2.","ref":"Grains.Timer.html#pull_with_tag/2","title":"Grains.Timer.pull_with_tag/2","type":"function"},{"doc":"See Grains.GenGrain.push/1.","ref":"Grains.Timer.html#push/1","title":"Grains.Timer.push/1","type":"function"},{"doc":"See Grains.GenGrain.push/2.","ref":"Grains.Timer.html#push/2","title":"Grains.Timer.push/2","type":"function"},{"doc":"","ref":"Grains.Timer.State.html","title":"Grains.Timer.State","type":"module"}]